#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <errno.h>
//#include <termios.h>
#include <pthread.h>
//#include <sys/types.h>
//#include <sys/stat.h>
#include <fcntl.h>
#include "../head/func_extern.h"
#include "../head/mg3.h"
#include "../head/control.h"
//#include "../main/pwm_enc.h"
#include "../head/motor.h"
#include "../mirs_two.h"

//プロトタイプ宣言
void rotary_straight();
void rotary_rotate();
void rotary_load();
//外部変数の宣言
int rotary_sensor_interrupt=0;
int rotary_flag=0;
int rotary_uss_r_value=0;
extern rotary_uss_thread();
extern rotary_sensor_thread(void);

void rotary(void){
//int main(void){
	int ret1,ret2;
	int c_left,c_right;
	int i;
	int dis_l,dis_r;
	int speed_l, speed_r;
	int x_l,x_r;
	int x_lr,dist;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
//スレッド設定
	pthread_t sensor_t;
        pthread_t uss_t;
	pthread_attr_t attr_sensor_t;
	pthread_attr_t attr_uss_t;
	pthread_attr_init (&attr_sensor_t);
	pthread_attr_init (&attr_uss_t);
	pthread_attr_setschedpolicy(&attr_sensor_t, SCHED_RR);		//スレッドのスケジューリング方針をラウンドロビンで
	pthread_attr_setschedpolicy(&attr_uss_t, SCHED_RR);
//モータデバイスオープン
	printf("opening device...\n");
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3)
			printf("no such file\n");
		else if(errno == 13)
			printf("permission\n");
		else
			printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		if(errno == 3)
			printf("no such file\n");
		else if(errno == 13)
			printf("permission\n");
		else
			printf("other\n");
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");
	motor_send_start_packet(fd1);
	motor_send_start_packet(fd2);
//スレッド作成
       	ret1 = pthread_create( &sensor_t, &attr_sensor_t,(void*)rotary_sensor_thread,NULL);
	if(ret1 != 0){
		printf ("sensor pthread create error!!\n");
		exit(1);
	}
       	ret2 = pthread_create( &uss_t, &attr_uss_t,(void*)rotary_uss_thread,NULL);
	if(ret2 != 0){
		printf ("uss_l pthread create error!!\n");
		exit(1);
	}

	rotary_load();	//ロータリーに入る前の動作

	printf("\n*****************motor_circle*****************\n");
	int rot=90;
	int time=rot*5;
	int radius=350;

	dis_l=rot*PI/180*(radius-MIRS_RADIUS);
	dis_r=rot*PI/180*(radius+MIRS_RADIUS);
	speed_l = 100*dis_l/(t_par*time);
	speed_r = 100*dis_r/(t_par*time);
	v_l = (char)speed_l;
	v_r = (char)speed_r;
	if(abs(speed_l) > VMAX){
		if(speed_l > 0)
			v_l = VMAX;
		else
			v_l = -VMAX;
	}
	if(abs(speed_r) > VMAX){
		if(speed_r > 0) 
			v_r = VMAX;
		else
			v_r = -VMAX;
	}
	v_lm = v_l;
	v_rm = v_r;
	for(i=0;i<4;i++){
		motor_send_clear_packet(fd1);
		motor_send_clear_packet(fd2);
		usleep(130*1000);
		motor_send_control_packet(fd1,v_l,Kp,Ki);
		motor_send_control_packet(fd2,v_r,Kp,Ki);
		usleep(130*1000);
		c_left=0;
		c_right=0;
		dist = (dis_l+dis_r)/2;

		while(1){
			motor_send_control_packet(fd1,v_lm,Kp,Ki);
			motor_send_control_packet(fd2,v_rm,Kp,Ki);
			usleep(130*1000);
			motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
			motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));	
			c_left=m_info_l.puls;
			c_right=m_info_r.puls;
			x_l=(int)(c_left*t_par);
			x_r=(int)(c_right*t_par);
			printf("vl = %d, vr = %d, xl = %d, xr = %d\n\n", v_lm, v_rm, x_l, x_r);
			x_lr = (x_l+x_r)/2;
			//目標距離までまだ遠いなら
			if( dis_l-x_l > CIR_HALF && dis_r-x_r > CIR_HALF){
				if(x_l-dis_l*x_lr/dist - x_r + dis_r*x_lr/dist > 10){
					v_lm=v_l-5;
					v_rm=v_r+5;
				}
				else if(x_r -dis_r*x_lr/dist - x_l + dis_l*x_lr/dist > 10){
					v_lm=v_l+5;
					v_rm=v_r-5;
				}
				else{
					v_lm = v_l;
					v_rm = v_r;
				}
			}
			//目標距離まである程度近づいたら速度を1/2に
			else if( (dis_l-x_l < CIR_HALF && dis_l-x_l > CIR_QUATER) && (dis_r-x_r < CIR_HALF && dis_r-x_r > CIR_QUATER) ){
				v_lm = v_l/2;
				v_rm = v_r/2;
			}
			//目標距離までだいぶ近づいたら速度を1/4に
			else if( (dis_l-x_l < CIR_QUATER && dis_l-x_l > CIR_END) && (dis_r-x_r < CIR_QUATER && dis_r-x_r > CIR_END) ){
				v_lm = v_l/4;
				v_rm = v_r/4;
			}
			//目標距離に到達したら調整して終了へ
			else if( abs(dis_l-x_l) < CIR_END && abs(dis_r-x_r) < CIR_END ){
				motor_send_control_packet(fd1,0,Kp,Ki);
				motor_send_control_packet(fd2,0,Kp,Ki);
				break;
			}
			else if( abs(dis_l-x_l) < CIR_END && dis_r-x_r > CIR_END ){
				v_lm = 0;
				v_rm = 3;
			}
			else if( dis_l-x_l > CIR_END && abs(dis_r-x_r) < CIR_END){
				v_lm = 3;
				v_rm = 0;
			}
			//目標距離を行き過ぎたらそのタイヤをBack
			else if(x_l > dis_l+CIR_END && x_r > dis_r+CIR_END){	//両方とも行き過ぎている
				v_lm = -3;
				v_rm = -3;
			}
			else if(x_l > dis_l+CIR_END && (dis_r-x_r < 0 && x_r < dis_r+CIR_END)){		//左は行き過ぎ，右は行き過ぎだが許容範囲内
				v_lm = -3;
				v_rm = 0;
			}
			else if(x_l > dis_l+CIR_END && (dis_r-x_r > 0 && x_r < dis_r+CIR_END)){		//左は行き過ぎ，右はまだ到達していない
				v_lm = -3;
				v_rm = 3;
			}
			else if( (dis_l-x_l < 0 && x_l < dis_l+CIR_END && x_r > dis_r+CIR_END)){		//左は行き過ぎだが許容範囲内，右は行き過ぎ
				v_lm = 0;
				v_rm = -3;
			}
			else if( (dis_l-x_l > 0 && x_l < dis_l+CIR_END && x_r > dis_r+CIR_END)){		//左はまだ到達していない，右は行き過ぎ
				v_lm = 3;
				v_rm = -3;
			}
		}
		printf("uss check now....\n");
		usleep(1000*1000);
		if(rotary_uss_r_value > 50){		//右側が空いていた場合
			rotary_rotate();
			usleep(1000*1000);
			rotary_straight();			//脱出
			break;
		}
	}
	motor_send_control_packet(fd1,0,Kp,Ki);
	motor_send_control_packet(fd2,0,Kp,Ki);
	motor_send_stop_packet(fd1);
	motor_send_stop_packet(fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	close(fd1);
	close(fd2);
	close(fd4);
	pthread_cancel(sensor_t);
	pthread_cancel(uss_t);
	return;
}

void rotary_load(void){
//変数宣言
	int c_left,c_right;
	int x_l,x_r;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
//スピード設定
	v_l = LOAD_SPEED;
	v_r = LOAD_SPEED;
	v_lm = v_l;					//初期速度を保存
	v_rm = v_r;
//send
	motor_send_clear_packet(fd1);			//エンコーダ値をクリア
	motor_send_clear_packet(fd2);
	usleep(130*1000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	usleep(130*1000);
	c_left=0;
	c_right=0;
//スタート
	printf("\n***************** load program *****************\n");
	while(1){
		//センサが反応するまで直進する
		while(rotary_flag == 0){
			//補正をかけながら直進
			if(x_l - x_r > 5){			//左タイヤの移動距離が多い場合
				v_lm = v_l-5;				//左-5 : 右+5
				v_rm = v_r+5;
			}
			else if(x_r - x_l > 5){		//右タイヤの移動距離が多い場合
				v_lm = v_l+5;				//左+5 : 右-5
				v_rm = v_r-5;
			}
			else{					//左右にズレがない場合
				v_lm = v_l;				//初期速度
				v_rm = v_r;
			}
			motor_send_control_packet(fd1,v_lm,Kp,Ki);
			motor_send_control_packet(fd2,v_rm,Kp,Ki);
			usleep(130*1000);
			motor_recv_status_packet(fd1,&(m_info_l.speed),&(m_info_l.pwm),&(m_info_l.puls));
			motor_recv_status_packet(fd2,&(m_info_r.speed),&(m_info_r.pwm),&(m_info_r.puls));
			c_left=m_info_l.puls;
			c_right=m_info_r.puls;
			x_l=(int)(c_left*t_par);
			x_r=(int)(c_right*t_par);
			printf("vl = %d, vr = %d, xl = %d, xr = %d\n\n", v_lm, v_rm, x_l, x_r);
		}
		//中心のポストを見つけたら
		if(rotary_sensor_interrupt == F_TS_FLAG){		//前のタッチセンサが反応
			motor_send_control_packet(fd1,0,Kp,Ki);
			motor_send_control_packet(fd2,0,Kp,Ki);
			printf ("find center post!\n");
			usleep(1000*1000);
			motor_send_control_packet(fd1,L_BACK_SPEED,Kp,Ki);
			motor_send_control_packet(fd2,R_BACK_SPEED,Kp,Ki);
			usleep(BACK_TIME*1000);
			motor_send_control_packet(fd1,0,Kp,Ki);
			motor_send_control_packet(fd2,0,Kp,Ki);
			usleep(1000*1000);
			rotary_rotate();		//右に90度回転
			rotary_flag = 0;
			break;
		}
		else if(rotary_sensor_interrupt == L_TS_FLAG)
			rotary_flag = 0;
		else if(rotary_sensor_interrupt == R_TS_FLAG)
			rotary_flag = 0;
	}
	motor_send_control_packet(fd1,0,Kp,Ki);
	motor_send_control_packet(fd2,0,Kp,Ki);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
}
